
/*
 * apricot.h:
 *      A Programming Interactive Calculate O Tron...
 *
 *	Copyright (c) 2023 by Gordon Henderson
 *
 *********************************************************************************
 * This file is part of Apricot:
 *    A PRogramable Interactive Calculate O Tron by Gordon Henderson
 *
 *    Apricot is distributed under a "Source Available" license.
 *	It is NOT Open source and must not be treated as such.
 *
 *    See the file LICENSE for details.
 *********************************************************************************
 */

// Values

#define	COT_FALSE	   0		// Same as C/BCPL False, but just to make sure...

#define	DEFAULT_MAX_FREE_RAM	8000
#define	DEFAULT_MAX_STACK	 128

#define	MAX_LINES		 250		// 250 lines of code ought to be enough for anyone...
#define	MAX_LINE_NUM 		9999		// Just because 
#define	MAX_LINE_LEN		  74		// 80 columns - 4 dig. lNum - space.

#define	TRUE	(1)
#define	FALSE	(0)

// Type of the numbers we're dealing with
//	32-bit signed integers.

typedef	int32_t ourNum ;

extern ourNum  acc ;
extern ourNum  variables    [26] ;			// 0-25; A-Z

extern ourNum *freeRam ;
extern ourNum *stackData ;
extern int     freeRamSize, stackSize ;

extern char    codeStore    [MAX_LINES * MAX_LINE_LEN] ;
extern int     lineNumbers  [MAX_LINES] ;
extern ourNum *codePointers [MAX_LINES] ;
extern char   *codeLines    [MAX_LINES] ;
extern int     numCodeLines ;
extern int     pc, pEnd ;
extern ourNum *stack ;
extern int     sp, fp ;
extern ourNum  aux1, aux2 ;
extern int	programEdited ;

// Functions used externally


extern void allClear    (void) ;
extern int  compileLine (char *line) ;
extern void insertLine  (int lineNum, char *line, int p) ;
